/* install-sdb-files.c - installs all sdb files in current directory */
/* Peter C. Dillinger, 4 Feb 2008 */
/* Public domain, no warranty */

#include <stdlib.h>
#include <stdio.h>
#include <process.h>
#include <windows.h>
#include <direct.h>

int go() {
	WIN32_FIND_DATA findFileData;
	HANDLE hFind;
	char exe[1025];
	int i;

	i = GetModuleFileName(NULL,exe,1024);
	if (i == 0) {
		printf("Error getting executable path.\n");
		fflush(stdout);
		return 2;
	}
	if (i >= 1023) {
		printf("Executable path too big.\n");
		fflush(stdout);
		return 3;
	}

	while (i > 0 && exe[i] != '\\') i--;
	exe[i] = '\0';

	if (!SetCurrentDirectory(exe)) {
		printf("Unable to change to directory of executable!\n");
		fflush(stdout);
		return 4;
	}

	hFind = FindFirstFile("*.sdb", &findFileData);
	if (hFind == INVALID_HANDLE_VALUE) {
		printf("No .sdb file found!\n");
		fflush(stdout);
		return 5;
	}

	do {
		snprintf(exe, 1024, "sdbinst \"%s\"", findFileData.cFileName);
		i = system(exe);
		if (i != 0) {
			(void)FindClose(hFind);
			return i;
		}
	} while (FindNextFile(hFind, &findFileData));
	(void)FindClose(hFind);
	return 0;
}

int main(int argc, char *argv[]) {
	int i = go();
	(void) system("pause");
	return i;
}
